summaryrefslogtreecommitdiffstats
path: root/contrib/gitiles
diff options
context:
space:
mode:
Diffstat (limited to 'contrib/gitiles')
-rwxr-xr-xcontrib/gitiles84
1 files changed, 84 insertions, 0 deletions
diff --git a/contrib/gitiles b/contrib/gitiles
new file mode 100755
index 0000000000..3e603b9af9
--- /dev/null
+++ b/contrib/gitiles
@@ -0,0 +1,84 @@
+#!/bin/bash
+#
+# Copyright (C) 2018 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+usage() {
+ me=`basename "$0"`
+ echo >&2 "Usage: $me [open] [-b branch] [path]"
+ exit 1
+}
+
+cmd_open() {
+ case "$(uname)" in
+ Darwin)
+ echo "open"
+ ;;
+ Linux)
+ echo "xdg-open"
+ ;;
+
+ *)
+ echo >&2 "Don't know how to open URLs on $(uname)"
+ exit 1
+ esac
+}
+
+URL=$(git config --get gitiles.url)
+
+if test -z "$URL" ; then
+ echo >&2 "gitiles.url must be set in .git/config"
+ exit 1
+fi
+
+while test $# -gt 0 ; do
+ case "$1" in
+ open)
+ CMD=$(cmd_open)
+ shift
+ ;;
+ -b|--branch)
+ shift
+ B=$1
+ shift
+ ;;
+ -h|--help)
+ usage
+ ;;
+
+ *)
+ P=$1
+ shift
+ esac
+done
+
+if test -z "$CMD" ; then
+ CMD=echo
+fi
+
+if test -z "$B" ; then
+ B=$(git rev-parse HEAD)
+fi
+
+URL="$URL/+/$B"
+
+if test -z "$P" ; then
+ P=$(git rev-parse --show-prefix)
+elif test ${P:0:2} = "./" ; then
+ P=$(git rev-parse --show-prefix)${P:2}
+fi
+
+URL="$URL/$P"
+
+$CMD $URL